#!/usr/bin/python

from httplib import HTTPConnection
from httplib import HTTPResponse
import sys
import re

def distance(a, b):
	global regex
	global conn
	# Get the page with the data on it
	conn.request("GET", "/cgi-bin/similarity/similarity.cgi?word1="+a+"&word2="+b+"&senses1=all&senses2=all&measure=all&rootnode=yes")
	response = conn.getresponse()
	# Parse the output
	restext = response.read()
	total = 0.0
	count = 0
	# Loop over the matches to find all the returned values
	match = regex.search(restext)
	while match:
		#print "Found %s" % (match.group(2))
		if match.group(1) != "vector_pairs": total += float(match.group(2))
		else: total += 2 * float(match.group(2))
		count += 1
		# Find the next match, starting at the end of the previous one
		match = regex.search(restext, match.end())
	#print "Total: %f, Count: %d, Average: %f" % (total, count, total/count)
	if count > 0: print "%s %s %f" % (a, b, total/count)
	else: print "%s %s 0" % (a, b)


# The regex to look for the results
regex = re.compile("(wup|path|lin|vector_pairs|vector) is ([.0-9]*)\.")
# The connection to request the pages
conn = HTTPConnection("marimba.d.umn.edu")
# No arguments provided
if len(sys.argv) == 1:
	line = sys.stdin.readline()
	while not line.strip() == ".":
		words = line.split()
		distance(words[0], words[1])
		line = sys.stdin.readline()
# Single command-line argument: file
if len(sys.argv) == 2:
	import fileinput
	for line in fileinput.input():
		words = line.split()
		distance(words[0], words[1])
# Two command-line arguments
if len(sys.argv) == 3:
	distance(sys.argv[1], sys.argv[2])
# Housekeeping
conn.close()
